angular.module('starter.services', ['ngResource'])

.factory('UserApi', function ($resource) {
	  return {
	  		apiLogin: function(user) {
	  			var email = user.email;
	  			var password = user.password;
	  			var type = user.type;
	  			var authtoken = user.authtoken;
	  			var devicetype = user.devicetype;
	  			var devicetoken = user.devicetoken;
		    	return $resource(window.tuk_tuk_api+'login', 
		    					{email:email,password:password,type:type,authtoken:authtoken,devicetype:devicetype,devicetoken:devicetoken}, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: {email:email,password:password,type:type,authtoken:authtoken,devicetype:devicetype,devicetoken:devicetoken},
                                    isArray: false,
                                    headers:{'X-API-TYPE':'notlogged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token}
                                 }
                            });
		    },
		    apiSignUp: function(user) {
	  			var email = user.email;
	  			var password = user.password;
	  			var tel = user.tel;
	  			var type = user.type;
	  			var authtoken = user.authtoken;
	  			var devicetype = user.devicetype;
	  			var devicetoken = user.devicetoken;
	  			var name = user.name;
		    	return $resource(window.tuk_tuk_api+'register', 
		    					{email:email,name:name,tel:tel,password:password,type:type,authtoken:authtoken,devicetype:devicetype,devicetoken:devicetoken}, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: {email:email,name:name,tel:tel,password:password,type:type,authtoken:authtoken,devicetype:devicetype,devicetoken:devicetoken},
                                    isArray: false,
                                    headers:{'X-API-TYPE':'notlogged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token}
                                 }
                            });
		    },
	  		apiSendForgotPwdToken: function(email) {
		    	return $resource(window.tuk_tuk_api+'user/forgot/password/send', 
		    					{email:email}, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: {email:email},
                                    isArray: false,
                                    headers:{'X-API-TYPE':'notlogged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token}
                                 }
                            });
		    },
	  		apiApplyForgotPwdToken: function(email,token) {
		    	return $resource(window.tuk_tuk_api+'user/forgot/password/apply', 
		    					{email:email,forgot_token:token}, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: {email:email,forgot_token:token},
                                    isArray: false,
                                    headers:{'X-API-TYPE':'notlogged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token}
                                 }
                            });
		    },
		    getUser: function(){
		    	var usr = null;
		    	if(window.localStorage['id']){
		    		usr = {id:window.localStorage['id'],email:window.localStorage['email']
		    			,tel:window.localStorage['tel'],avg_ratings:window.localStorage['avg_ratings']
		    			,name:window.localStorage['name'],token:window.localStorage['token']
		    			,fid:window.localStorage['fid'],type:window.localStorage['type']
		    			,vehicleno:window.localStorage['vehicleno'],vehicletype:window.localStorage['vehicletype']
		    			,gender:window.localStorage['gender'],profilepic:window.localStorage['profilepic']
		    			,lnch:window.localStorage['lnch']};
		    	}	 			
		    	return usr;
		    },
	};
})

.factory('Trip', function ($resource,UserApi) {
	  return {
	  		createTrip: function(trip) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trip/create',trip, {
                                 save: {
                                    method: 'POST',
                                    params: trip,
                                    timeout:window.timeout_value,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    getTripById: function(trip) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trip/get',trip, {
                                 get: {
                                    method: 'GET',
                                    params: trip,
                                    timeout:window.timeout_value,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    getTrips: function(trip) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trips/get',trip, {
                                 get: {
                                    method: 'GET',
                                    params: trip,
                                    timeout:window.timeout_value,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    sendRequest: function(trip) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trip/request/send',trip, {
							save: {
                                    method: 'POST',
                                    params: trip,
                                    timeout:window.timeout_value,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    acceptRequest: function(trip) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trip/request/accept',trip, {
                                 save: {
                                    method: 'POST',
                                    params: trip,
                                    timeout:window.timeout_value,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    getUserById: function(usr) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'user/get',usr, {
                                 get: {
                                    method: 'GET',
                                    timeout:window.timeout_value,
                                    params: usr,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    getTripByPassanger: function(usr) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trip/pessanger/get/current',usr, {
                                 get: {
                                    method: 'GET',
                                    timeout:window.timeout_value,
                                    params: usr,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    quitTripPassenger: function(trip) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trip/quit/passenger',trip, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: trip,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    quitTripDriver: function(trip) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'trip/quit/driver',trip, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: trip,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    submitFeedback: function(feedback) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'rate/comment/submit',feedback, {
                                 save: {
                                    method: 'POST',
                                    params: feedback,
                                    timeout:window.timeout_value,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
	};
})

.factory('Map', function ($resource,$cordovaGeolocation) {
	  return {
	  		getLocationInText: function(cordinates) {
		    	return $resource('http://maps.googleapis.com/maps/api/geocode/json?latlng='+cordinates.lat+','+cordinates.lon+'&sensor=false',{}, {
                                 get: {
                                    method: 'GET',
                                    timeout:window.timeout_value,
                                 }
                            });
		    },
		    getLocationInLatLon: function(address) {
		    	return $resource('http://maps.google.com/maps/api/geocode/json?address='+address+'&sensor=false',{}, {
                                 get: {
                                    method: 'GET',
                                    timeout:window.timeout_value,
                                 }
                            });
		    },
		    getCurrentLocation: function(callback) {
		    	var posOptions = {timeout: 10000, enableHighAccuracy: true};
				$cordovaGeolocation.getCurrentPosition(posOptions)
				.then(function (position) {
				      callback(position);
			    }, function(err) {
			    	$ionicPopup.alert({ 
									title: 'GPS Location Error',
                                    template: '<center>Please enable your gps location.</center>',
                                    buttons: [{
                                                text: '<b>OK</b>',
                                                type: 'button-assertive'
                                              },]
                                    });
					callback(null);
				});
		    },
			getCurrentLocationEveryMin: function(callback) {
				 var watchOptions = {
				    frequency : 1000,
				    timeout : 5000,
				    enableHighAccuracy: false // may cause errors if true
				  };
				  
				  var watch = $cordovaGeolocation.watchPosition(watchOptions);
				  watch.then(null,function(err) {
					callback(err);
				  },
				  function(position) {
				      callback(position);
				  });
		    },
			stopEveryMinLocationUpdator: function(callback) {
				$cordovaGeolocation.clearWatch(watch)
				.then(function(result) {
				     callback(true);
				}, function (error) {
				     callback(false);
				});
		    },
	};
})

.factory('Activity', function ($resource,UserApi,$ionicPopup,$cordovaFileTransfer,$rootScope) {
	  return {
	  		getActivitiesByUser: function(activity) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'activity/user/all',activity, {
                                 get: {
                                    method: 'GET',
                                    params: activity,
                                    timeout:window.timeout_value,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
	  		getUserById: function(usr) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'user/get',usr, {
                                 get: {
                                    method: 'GET',
                                    timeout:window.timeout_value,
                                    params: usr,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    switchUserType: function(types) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'user/type/switch',types, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: types,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    checkInternetConnection: function() {
		    	if(navigator.network){
				    if(navigator.network.connection.type == Connection.NONE){
		    			$rootScope.internetConnectionSlow(true,1);  
				    	return false;
				    }else{
    					$rootScope.internetConnectionSlow(false,1);
				    	return true;
				    }
			    }else{
    				$rootScope.internetConnectionSlow(false,1);
			    	return true;
			    }
			    
		    },
		    changeAccount: function(account) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'user/change/account',account, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: account,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    logoutAccount: function(logout) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'logout',logout, {
                                 save: {
                                    method: 'POST',
                                    params: logout,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    changePwd: function(account) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'user/change/password',account, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: account,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    sendPanic: function(panic) {
	  			var logged_user = UserApi.getUser();
		    	return $resource(window.tuk_tuk_api+'user/hold/panic',panic, {
                                 save: {
                                    method: 'POST',
                                    timeout:window.timeout_value,
                                    params: panic,
                                    isArray: false,
                                    headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}
                                 }
                            });
		    },
		    uploadPicture: function(filePath) {
	  			var logged_user = UserApi.getUser();
	  			var options = {headers:{'X-API-TYPE':'logged','X-API-VALID':window.tuk_api_valid,'X-API-TOKEN':window.tuk_api_token,
                                    		'X-USER-ID':logged_user.id,'X-FIREBASE-TOKEN':logged_user.token}};
                var params = {};
				params.id = logged_user.id;
				options.params = params;
				options.fileKey="profilepic";
			
	  			return $cordovaFileTransfer.upload(window.tuk_tuk_api+'user/upload/picture', filePath, options);
		    },
	};
});

